《操作系统》的实验代码。
25개 이상의 토픽을 선택하실 수 없습니다. Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

292 lines
7.6 KiB

  1. PROJ := 8
  2. EMPTY :=
  3. SPACE := $(EMPTY) $(EMPTY)
  4. SLASH := /
  5. V := @
  6. #need llvm/cang-3.5+
  7. #USELLVM := 1
  8. # try to infer the correct GCCPREFX
  9. ifndef GCCPREFIX
  10. GCCPREFIX := $(shell if i386-ucore-elf-objdump -i 2>&1 | grep '^elf32-i386$$' >/dev/null 2>&1; \
  11. then echo 'i386-ucore-elf-'; \
  12. elif objdump -i 2>&1 | grep 'elf32-i386' >/dev/null 2>&1; \
  13. then echo ''; \
  14. else echo "***" 1>&2; \
  15. echo "*** Error: Couldn't find an i386-ucore-elf version of GCC/binutils." 1>&2; \
  16. echo "*** Is the directory with i386-ucore-elf-gcc in your PATH?" 1>&2; \
  17. echo "*** If your i386-ucore-elf toolchain is installed with a command" 1>&2; \
  18. echo "*** prefix other than 'i386-ucore-elf-', set your GCCPREFIX" 1>&2; \
  19. echo "*** environment variable to that prefix and run 'make' again." 1>&2; \
  20. echo "*** To turn off this error, run 'gmake GCCPREFIX= ...'." 1>&2; \
  21. echo "***" 1>&2; exit 1; fi)
  22. endif
  23. # try to infer the correct QEMU
  24. ifndef QEMU
  25. QEMU := $(shell if which qemu-system-i386 > /dev/null; \
  26. then echo 'qemu-system-i386'; exit; \
  27. elif which i386-elf-qemu > /dev/null; \
  28. then echo 'i386-elf-qemu'; exit; \
  29. elif which qemu > /dev/null; \
  30. then echo 'qemu'; exit; \
  31. else \
  32. echo "***" 1>&2; \
  33. echo "*** Error: Couldn't find a working QEMU executable." 1>&2; \
  34. echo "*** Is the directory containing the qemu binary in your PATH" 1>&2; \
  35. echo "***" 1>&2; exit 1; fi)
  36. endif
  37. # eliminate default suffix rules
  38. .SUFFIXES: .c .S .h
  39. # delete target files if there is an error (or make is interrupted)
  40. .DELETE_ON_ERROR:
  41. # define compiler and flags
  42. ifndef USELLVM
  43. HOSTCC := gcc
  44. HOSTCFLAGS := -g -Wall -O2
  45. CC := $(GCCPREFIX)gcc
  46. CFLAGS := -fno-builtin -Wall -ggdb -m32 -gstabs -nostdinc $(DEFS)
  47. CFLAGS += $(shell $(CC) -fno-stack-protector -E -x c /dev/null >/dev/null 2>&1 && echo -fno-stack-protector)
  48. else
  49. HOSTCC := clang
  50. HOSTCFLAGS := -g -Wall -O2
  51. CC := clang
  52. CFLAGS := -fno-builtin -Wall -g -m32 -mno-sse -nostdinc $(DEFS)
  53. CFLAGS += $(shell $(CC) -fno-stack-protector -E -x c /dev/null >/dev/null 2>&1 && echo -fno-stack-protector)
  54. endif
  55. GDB := $(GCCPREFIX)gdb
  56. CTYPE := c S
  57. LD := $(GCCPREFIX)ld
  58. LDFLAGS := -m $(shell $(LD) -V | grep elf_i386 2>/dev/null)
  59. LDFLAGS += -nostdlib
  60. OBJCOPY := $(GCCPREFIX)objcopy
  61. OBJDUMP := $(GCCPREFIX)objdump
  62. COPY := cp
  63. MKDIR := mkdir -p
  64. MV := mv
  65. RM := rm -f
  66. AWK := awk
  67. SED := sed
  68. SH := sh
  69. TR := tr
  70. TOUCH := touch -c
  71. OBJDIR := obj
  72. BINDIR := bin
  73. ALLOBJS :=
  74. ALLDEPS :=
  75. TARGETS :=
  76. include tools/function.mk
  77. listf_cc = $(call listf,$(1),$(CTYPE))
  78. # for cc
  79. add_files_cc = $(call add_files,$(1),$(CC),$(CFLAGS) $(3),$(2),$(4))
  80. create_target_cc = $(call create_target,$(1),$(2),$(3),$(CC),$(CFLAGS))
  81. # for hostcc
  82. add_files_host = $(call add_files,$(1),$(HOSTCC),$(HOSTCFLAGS),$(2),$(3))
  83. create_target_host = $(call create_target,$(1),$(2),$(3),$(HOSTCC),$(HOSTCFLAGS))
  84. cgtype = $(patsubst %.$(2),%.$(3),$(1))
  85. objfile = $(call toobj,$(1))
  86. asmfile = $(call cgtype,$(call toobj,$(1)),o,asm)
  87. outfile = $(call cgtype,$(call toobj,$(1)),o,out)
  88. symfile = $(call cgtype,$(call toobj,$(1)),o,sym)
  89. # for match pattern
  90. match = $(shell echo $(2) | $(AWK) '{for(i=1;i<=NF;i++){if(match("$(1)","^"$$(i)"$$")){exit 1;}}}'; echo $$?)
  91. # >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  92. # include kernel/user
  93. INCLUDE += libs/
  94. CFLAGS += $(addprefix -I,$(INCLUDE))
  95. LIBDIR += libs
  96. $(call add_files_cc,$(call listf_cc,$(LIBDIR)),libs,)
  97. # -------------------------------------------------------------------
  98. # kernel
  99. KINCLUDE += kern/debug/ \
  100. kern/driver/ \
  101. kern/trap/ \
  102. kern/mm/ \
  103. kern/libs/ \
  104. kern/sync/ \
  105. kern/fs/ \
  106. kern/process \
  107. kern/schedule
  108. KSRCDIR += kern/init \
  109. kern/libs \
  110. kern/debug \
  111. kern/driver \
  112. kern/trap \
  113. kern/mm \
  114. kern/sync \
  115. kern/fs \
  116. kern/process \
  117. kern/schedule
  118. KCFLAGS += $(addprefix -I,$(KINCLUDE))
  119. $(call add_files_cc,$(call listf_cc,$(KSRCDIR)),kernel,$(KCFLAGS))
  120. KOBJS = $(call read_packet,kernel libs)
  121. # create kernel target
  122. kernel = $(call totarget,kernel)
  123. $(kernel): tools/kernel.ld
  124. $(kernel): $(KOBJS)
  125. @echo + ld $@
  126. $(V)$(LD) $(LDFLAGS) -T tools/kernel.ld -o $@ $(KOBJS)
  127. @$(OBJDUMP) -S $@ > $(call asmfile,kernel)
  128. @$(OBJDUMP) -t $@ | $(SED) '1,/SYMBOL TABLE/d; s/ .* / /; /^$$/d' > $(call symfile,kernel)
  129. $(call create_target,kernel)
  130. # -------------------------------------------------------------------
  131. # create bootblock
  132. bootfiles = $(call listf_cc,boot)
  133. $(foreach f,$(bootfiles),$(call cc_compile,$(f),$(CC),$(CFLAGS) -Os -nostdinc))
  134. bootblock = $(call totarget,bootblock)
  135. $(bootblock): $(call toobj,boot/bootasm.S) $(call toobj,$(bootfiles)) | $(call totarget,sign)
  136. @echo + ld $@
  137. $(V)$(LD) $(LDFLAGS) -N -T tools/boot.ld $^ -o $(call toobj,bootblock)
  138. @$(OBJDUMP) -S $(call objfile,bootblock) > $(call asmfile,bootblock)
  139. @$(OBJCOPY) -S -O binary $(call objfile,bootblock) $(call outfile,bootblock)
  140. @$(call totarget,sign) $(call outfile,bootblock) $(bootblock)
  141. $(call create_target,bootblock)
  142. # -------------------------------------------------------------------
  143. # create 'sign' tools
  144. $(call add_files_host,tools/sign.c,sign,sign)
  145. $(call create_target_host,sign,sign)
  146. # -------------------------------------------------------------------
  147. # create ucore.img
  148. UCOREIMG := $(call totarget,ucore.img)
  149. $(UCOREIMG): $(kernel) $(bootblock)
  150. $(V)dd if=/dev/zero of=$@ count=10000
  151. $(V)dd if=$(bootblock) of=$@ conv=notrunc
  152. $(V)dd if=$(kernel) of=$@ seek=1 conv=notrunc
  153. $(call create_target,ucore.img)
  154. # -------------------------------------------------------------------
  155. # create swap.img
  156. SWAPIMG := $(call totarget,swap.img)
  157. $(SWAPIMG):
  158. $(V)dd if=/dev/zero of=$@ bs=1M count=128
  159. $(call create_target,swap.img)
  160. # >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  161. $(call finish_all)
  162. IGNORE_ALLDEPS = clean \
  163. dist-clean \
  164. grade \
  165. touch \
  166. print-.+ \
  167. handin
  168. ifeq ($(call match,$(MAKECMDGOALS),$(IGNORE_ALLDEPS)),0)
  169. -include $(ALLDEPS)
  170. endif
  171. # files for grade script
  172. TARGETS: $(TARGETS)
  173. .DEFAULT_GOAL := TARGETS
  174. QEMUOPTS = -hda $(UCOREIMG) -drive file=$(SWAPIMG),media=disk,cache=writeback
  175. .PHONY: qemu qemu-nox debug debug-nox
  176. qemu-mon: $(UCOREIMG) $(SWAPIMG)
  177. $(V)$(QEMU) -no-reboot -monitor stdio $(QEMUOPTS) -serial null
  178. qemu: $(UCOREIMG) $(SWAPIMG)
  179. $(V)$(QEMU) -no-reboot -parallel stdio $(QEMUOPTS) -serial null
  180. qemu-nox: $(UCOREIMG) $(SWAPIMG)
  181. $(V)$(QEMU) -no-reboot -serial mon:stdio $(QEMUOPTS) -nographic
  182. TERMINAL := gnome-terminal
  183. debug: $(UCOREIMG) $(SWAPIMG)
  184. $(V)$(QEMU) -S -s -parallel stdio $(QEMUOPTS) -serial null &
  185. $(V)sleep 2
  186. $(V)$(TERMINAL) -e "$(GDB) -q -x tools/gdbinit"
  187. debug-nox: $(UCOREIMG) $(SWAPIMG)
  188. $(V)$(QEMU) -S -s -serial mon:stdio $(QEMUOPTS) -nographic &
  189. $(V)sleep 2
  190. $(V)$(TERMINAL) -e "$(GDB) -q -x tools/gdbinit"
  191. .PHONY: grade touch
  192. GRADE_GDB_IN := .gdb.in
  193. GRADE_QEMU_OUT := .qemu.out
  194. HANDIN := proj$(PROJ)-handin.tar.gz
  195. TOUCH_FILES := kern/trap/trap.c
  196. MAKEOPTS := --quiet --no-print-directory
  197. grade:
  198. $(V)$(MAKE) $(MAKEOPTS) clean
  199. $(V)$(SH) tools/grade.sh
  200. touch:
  201. $(V)$(foreach f,$(TOUCH_FILES),$(TOUCH) $(f))
  202. print-%:
  203. @echo $($(shell echo $(patsubst print-%,%,$@) | $(TR) [a-z] [A-Z]))
  204. .PHONY: clean dist-clean handin packall tags
  205. clean:
  206. $(V)$(RM) $(GRADE_GDB_IN) $(GRADE_QEMU_OUT) cscope* tags
  207. -$(RM) -r $(OBJDIR) $(BINDIR)
  208. dist-clean: clean
  209. -$(RM) $(HANDIN)
  210. handin: packall
  211. @echo Please visit http://learn.tsinghua.edu.cn and upload $(HANDIN). Thanks!
  212. packall: clean
  213. @$(RM) -f $(HANDIN)
  214. @tar -czf $(HANDIN) `find . -type f -o -type d | grep -v '^\.*$$' | grep -vF '$(HANDIN)'`
  215. tags:
  216. @echo TAGS ALL
  217. $(V)rm -f cscope.files cscope.in.out cscope.out cscope.po.out tags
  218. $(V)find . -type f -name "*.[chS]" >cscope.files
  219. $(V)cscope -bq
  220. $(V)ctags -L cscope.files